#property copyright "Copyright  2009, Relrin" 
#property link      "Relrin78@gmail.com" 

#property indicator_chart_window 
#property indicator_buffers 3 
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red 
#property indicator_width2 2
#property indicator_color3 Yellow 
#property indicator_width3 2
//---- input parameters 
extern int       period=14; 
extern int       method=3;                         // MODE_SMA 
extern int       price=0;                          // PRICE_CLOSE 
extern double    FlatPips=0.2;
//---- buffers 
double Uptrend[];
double Dntrend[];
double Flat[];
double ExtMapBuffer[]; 


//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
{ 
    IndicatorBuffers(4);  
    SetIndexBuffer(0, Uptrend);
    SetIndexBuffer(1, Dntrend); 
    SetIndexBuffer(2, Flat); 
    SetIndexBuffer(3, ExtMapBuffer); 
    ArraySetAsSeries(ExtMapBuffer, true);
    
    SetIndexStyle(0,DRAW_LINE);
    SetIndexStyle(1,DRAW_LINE);
    SetIndexStyle(2,DRAW_LINE);
    
    IndicatorShortName("Pulse Slope_V3"); 

    return(0); 
} 

//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
{ 
    // ???? ????? ?????? ?????? 
    return(0); 
} 

//+------------------------------------------------------------------+ 
//| ?????????? ???????                                               | 
//+------------------------------------------------------------------+ 
double WMA(int x, int p) 
{ 
    return(iMA(NULL, 0, p, 0, method, price, x));    
} 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
{ 
    int counted_bars = IndicatorCounted(); 
    
    if (counted_bars < 0) 
        return(-1); 
                  
    int p = MathSqrt(period);              
    int e = Bars - counted_bars + period + 1; 
    
    double vect[], trend[]; 
    
    if (e > Bars) e = Bars;    

    ArrayResize(vect, e); 
    ArraySetAsSeries(vect, true);
    ArrayResize(trend, e); 
    ArraySetAsSeries(trend, true); 
    
    for (int x = 0; x < e; x++) 
      vect[x] = 2*WMA(x, period/2) - WMA(x, period);        

    for (x = 0; x < e-period; x++)
      ExtMapBuffer[x] = iMAOnArray(vect, 0, p, 0, method, x);  

    for (x = e-period; x >= 0; x--)
      {     
       trend[x] = trend[x+1];
       if (ExtMapBuffer[x] >= ExtMapBuffer[x+1] + FlatPips*Point) 
         trend[x] =1;
        else
         if (ExtMapBuffer[x] <= ExtMapBuffer[x+1] - FlatPips*Point) 
           trend[x] =-1;
          else
           trend[x] = 0; 
    
       if (trend[x]>0)
         { 
          Uptrend[x] = ExtMapBuffer[x]; 
          if (trend[x+1]<=0) Uptrend[x+1]=ExtMapBuffer[x+1];
          Dntrend[x] = EMPTY_VALUE;
         }
        else              
         if (trend[x]<0)
           { 
            Dntrend[x] = ExtMapBuffer[x]; 
            if (trend[x+1]>=0) Dntrend[x+1]=ExtMapBuffer[x+1];
            Uptrend[x] = EMPTY_VALUE;
           }              
          else
           {
            Dntrend[x] = EMPTY_VALUE;
            Uptrend[x] = EMPTY_VALUE;
            Flat[x] = ExtMapBuffer[x];
            if (trend[x+1] != 0) Flat[x+1]=ExtMapBuffer[x+1];
           } 
      }
    
    return(0); 
} 
//+------------------------------------------------------------------+ 